#include <iostream>
using namespace std;
int main(){
	int n,m;
    cin>>n>>m;
    int niz[n][m];
	
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> niz[i][j]; 
            

	int q;
	cin >> q;
	
	int prepreke[2][q];
	
	for(int i=0;i<2;i++)
		for(int j=0;j<q;j++)
			cin >> prepreke[i][j];
	
		
	for(int v=0;v<q;v++){  // i kordinata koju treba preskociti
	int brNavijaca = 0;
		for(int k=0;k<2;k++){ // j kordinata koju treba preskociti
		
			for(int i=0;i<n;i++){
    			if(i!=0){
    				brNavijaca+=niz[i][m-1];
				}
				else{
					for(int j=0;j<m;j++){
						int g = prepreke[v][0];
						int p = prepreke[v][1];
						if(g-1==i && p-1==j){
							i++;
							j--;
							brNavijaca+=niz[i][j];
						}else
							brNavijaca+=niz[i][j];
					}
				}
				
			}
					
		}	
		
		cout << brNavijaca/2 << endl;	
	}

    
	
    	
}